/****************************************************************************
** Form interface generated from reading ui file 'testdialog.ui'
**
** Created: Mon Feb 24 14:28:49 2003
**      by:  The User Interface Compiler (uic)
**
** WARNING! All changes made in this file will be lost!
****************************************************************************/
#ifndef FASTPHOTOMETRY_H
#define FASTPHOTOMETRY_H

#include <qvariant.h>
#include <qdialog.h>
#include "OmSourceParameters.h"
#include "OmSourceBrowser.h"
#include <vector>
#include <cstring>
#include "qdatetime.h"

class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QCheckBox;
class QRadioButton;
class OmSourceGroupBox;
class QLineEdit;
class OmSourceButton;
class QSpinBox;
class OmSourceLog;
class OmImageDisplay;
class QComboBox;
class OmSourceLabel;
class QTimer;
class OmSourceEdit;
class OmSpinBox2;
class OmSourceLabelEdit;
class OmSpinBox;

/************************************************
* Dialogue for doing interactive photometry
************************************************/  
class FastPhotometryDlg : public QDialog

{ 
    Q_OBJECT
protected:
    void mouseReleaseEvent( QMouseEvent * ){};
 


private:
    int _sourceNo;  // The number of the source in the list for photometry
    int _photometryType;
    OmImageDisplay *_display;
   

    const OmSourceBrowser::ObsDetails* _obsDetails;
  
    const OmSourceBrowser::ImageDetails* _imageDetails;
  
  
  
    OmSourceParameter _source;         // The source for photometry source
  ;
    OmSourceParameter _oldSource;
    

    float _calApertureRadius;
    float _apertureRadius;
    int _zoomFactor; 
    bool _displayUpdated;
    bool _fixedBackground;
    string _oldRegionsColour;

    vector<string> _colourList;
    int _innerBckRadius;
    int _outerBckRadius;    
public:
    
    FastPhotometryDlg(const int no, OmImageDisplay *display, 
		  const OmSourceBrowser::ObsDetails* obsDetails,
                  const OmSourceBrowser::ImageDetails* imageDetails,
                  const string, 
                  vector<string> colourList,
                  QWidget* parent = 0, 
                  const char* name = 0, 
                  bool modal = TRUE, 
                  WFlags fl = 0);
 
    ~FastPhotometryDlg();
    void LoadSourceDetails();
    void initApertureSpinBoxes();
  

   

    void printHeading(QPainter* p,  
                       QFontMetrics* fm,  
                       QPaintDeviceMetrics* metrics,
                       const int MARGIN, int &yPos);

    void print();
    typedef void(FastPhotometryDlg::*PRINT)(QPrinter* printer, QPainter* p,  
				       QFontMetrics *fm,  QPaintDeviceMetrics* metrics);





    PRINT Print;
 
     
 

private slots:

     void photometryTypeHasChanged( int type );
     void fixedBackgroundHasChanged( bool );

     void apertureRadiusHasChanged(int value);

     void innerAnnulusRadiusHasChanged(int value);
     void outerAnnulusRadiusHasChanged(int value);
   
     void colour1Changed( int );
     void colour2Changed( int );
     void weightingHasChanged(bool); 
     void showHelpInformation();


     void compute();
     void updateCputime();
     void stopTimer();
   

     void print1(); 
     void print2(); 
    
 
     
     void deleteAverageMagList();


     void printLog(QPrinter* printer, QPainter* p,  
		  QFontMetrics* fm,  QPaintDeviceMetrics* metrics);

     void printAverages(QPrinter* printer, QPainter* p,  
		      QFontMetrics *fm,  QPaintDeviceMetrics* metrics);

     

     void cancel();
       
     void showPhotometryInformation();
     void showBackgroundDlg();     
     void getBackgroundValue();    
     void numberToFitHasChanged(int );
     virtual void mousePressEvent( QMouseEvent* event);

     public slots:
         void close() {done(1); }; 
         void updateDisplay();

 
 private:

     static float signalToNoise(const float &, const float &, const float&);
     void computeAverage();  
  
     void startTimer();   
     void setToolTips();  


     void photometricConstants();
    


  
     static void computeABMagsAndFluxes(float rate, float rateErr, 
            float &mag, float &magErr, float &flux, float &fluxErr);


     /*****************************************************
      * observation information 
      **************************************************/
     OmSourceGroupBox* _obsDetailsGroupBox;
     OmSourceLabel* _filterLabel;
     OmSourceLabel* _exposureLabel;
 
     
   
     OmSourceLabel *_instructionsLabel;




    /*******************************************************
     * Annuli
     *******************************************************/
    
    OmSourceGroupBox* _annuliGroupBox;
    OmSourceLabel* _apertureTxt;
    QSpinBox* _apertureSpinBox;
    OmSourceLabel*_innerBckTxt;
    QSpinBox*_innerBckSpinBox;
    OmSourceLabel* _outerBckTxt;
    QSpinBox* _outerBckSpinBox;

   

    OmSpinBox*  _spinBoxColour1;
    OmSpinBox*  _spinBoxColour2;

    



    /*******************************************************
     * Raw rates
     *******************************************************/
    OmSourceGroupBox* _rawRateGroupBox;
    //    OmSourceLabelEdit* _rawTotalRateEdt;
    OmSourceLabel* _rawTotalRateTxt;
    OmSourceEdit* _rawTotalRateEdt;

    OmSourceLabel* _rawTotalRateErrTxt;
 
 	
    OmSourceEdit* _rawTotalRateErrEdt;

    OmSourceLabel* _rawBackgroundRateTxt;
    OmSourceEdit* _rawBackgroundRateEdt;


    OmSourceLabel* _rawBackgroundRateErrTxt;
    OmSourceEdit* _rawBackgroundRateErrEdt;


    /*******************************************************
     * Background subtracted raw rates
     *******************************************************/
  

    OmSourceLabel* _rawBackgroundSubtractedRateTxt;
    OmSourceEdit* _rawBackgroundSubtractedRateEdt;


    OmSourceLabel* _rawBackgroundSubtractedRateErrTxt;
    OmSourceEdit* _rawBackgroundSubtractedRateErrEdt;


    /*******************************************************
     * Corrected Raw rates
     *******************************************************/
    OmSourceGroupBox* _corrRateGroupBox;
    OmSourceLabel* _corrTotalRateTxt;
    OmSourceEdit* _corrTotalRateEdt;
    OmSourceLabel* _corrTotalRateErrTxt;
    OmSourceEdit* _corrTotalRateErrEdt;
    OmSourceLabel* _corrBackgroundRateTxt;
    OmSourceEdit* _corrBackgroundRateEdt;
    OmSourceLabel* _corrBackgroundRateErrTxt;
    OmSourceEdit* _corrBackgroundRateErrEdt;

    

    /*******************************************************
     * Corrected Background subtracted raw rates
     *******************************************************/
  

    OmSourceLabel* _corrBackgroundSubtractedRateTxt;

    OmSourceEdit* _corrBackgroundSubtractedRateEdt;

    OmSourceLabel* _corrBackgroundSubtractedRateErrTxt;

    OmSourceEdit* _corrBackgroundSubtractedRateErrEdt;


    /**********************************************
     * Instrumental magnitude
     *********************************************/
    OmSourceGroupBox* _magnitudeGroupBox;
 
    OmSourceLabel* _magnitudeTxt;

    OmSourceEdit* _magnitudeEdt;
    OmSourceLabel* _magnitudeErrTxt;

    OmSourceEdit* _magnitudeErrEdt;
    OmSourceLabel* _signalToNoiseTxt;

    OmSourceEdit* _signalToNoiseEdt;
   

    


    /*******************************************************
    * AB mags and fluxes
    *******************************************************/


    OmSourceLabel* _ABMagnitudeTxt;
    OmSourceEdit* _ABMagnitudeEdt;
    OmSourceLabel* _ABMagnitudeErrTxt;
    OmSourceEdit* _ABMagnitudeErrEdt;



    OmSourceLabel* _ABFluxTxt;
    OmSourceEdit* _ABFluxEdt;
    OmSourceLabel* _ABFluxErrTxt;
    OmSourceEdit* _ABFluxErrEdt;







    /****************************************
    * Corrections
    **************************************/

    OmSourceGroupBox* _correctionsGroupBox;
    OmSourceLabel*  _coincCorrectionTxt1;
    OmSourceEdit* _coincCorrectionEdt1;
    OmSourceLabel*  _coincCorrectionTxt2;
    OmSourceEdit* _coincCorrectionEdt2;


    OmSourceLabel*  _psf1CorrectionTxt;  
    OmSourceEdit* _psf1CorrectionEdt;
    OmSourceLabel*  _psf2CorrectionTxt;
    OmSourceEdit* _psf2CorrectionEdt;
    OmSourceLabel*  _deadFractionCorrectionTxt;
    OmSourceEdit* _deadFractionCorrectionEdt;
    OmSourceLabel*  _tdsCorrectionTxt;
    OmSourceEdit* _tdsCorrectionEdt;


    OmSourceButton* _cancelButton;

    OmSourceButton* _finishButton;

    OmSourceButton* _computeBtn;





    /******************************************************
     * The following are for getting the background
     * when it is "fixed"
     *******************************************************/
    OmSourceButton* _computeBackgroundBtn;
    OmSourceButton* _inputBackgroundBtn;
  

    OmSourceEdit* _backgroundEdt;
    OmSourceLabel*  _backgroundTxt;
    


     /******************************************************
     * The following are for getting the number
     * of sources to be included in the fit
     *******************************************************/

     OmSourceLabel*  _noToFitTxt;
 
     QSpinBox* _noToFitSpinBox;





    // The logger widgets

    OmSourceGroupBox* _loggerGroupBox;
    OmSourceLog*     _logger;
  
    QComboBox* _averageMagList;

    OmSourceButton* _printLogBtn;

    OmSourceButton* _deleteAveragesBtn;
    OmSourceButton* _printAveragesBtn;
    OmSourceButton* _growthCurveBtn;




    QRadioButton * _photometryTypeRadioBtn[3];
    QCheckBox   *_fixedBackgroundCheckBox;
    QCheckBox   *_weightingCheckBox;







 
    float* _magnitude;
    float* _magnitudeError;
    int _count;
    QTimer* _timer;
  
    float _backgroundUserValue;
    float _backgroundRegionsValue;
 
    
    float _backgroundMode;

    float _backgroundError;

    static string _colour1, _colour2;
    static int _colour1No, _colour2No;
    float _nx, _ny;
    int _noSources; 
    int _numberToFit;
    vector<int> _fitNo;
    QTime _time;
};

#endif // FASTPHOTOMETRY_H



