#ifndef OmSourceBackgroundDlg_h
#define OmSourceBackgroundDlg_h
#include <qapplication.h>

#include <qdialog.h>
#include <qstring.h>
#include <qtooltip.h>
#include "OmSourceVersionNo.h"
#include <vector>
#include <map>
#include <iostream>
#include <qspinbox.h>
class   OmSourceParameters;
class OmSourceButton;
class OmSourceLabel;
class QTable;
class OmImageDisplay;
class QTimer;
class OmSourceParameter;
class OmSourceLabel;
class QSpinBox;
class Average;
class QCheckBox;
class OmSpinBox;
class QTime;
class OmSourceBrowser;





/*********************************************************
 *
 *
 ********************************************************/
class AddSourcesDlg : public QDialog
{
    Q_OBJECT
     
 private slots:
      void deleteList();    
    void mousePressEvent( QMouseEvent *e );
    void updateRegions(); 
    void apertureRadiusHasChanged(int radius);
    void accept1();    
    void cancel1();
    void oldRegionColourChanged(int);

    void newRegionColourChanged(int);

    void updateTimeChanged( int no );

    void redrawRegions();

    void showHelpInformation();




public:
    AddSourcesDlg(QWidget *parent,  OmImageDisplay *imageDispaly, float);
    ~AddSourcesDlg();
 
 private:

    void updateTable(float x, float y, float radius, 
           float counts, OmSourceParameter & );
    void update();
    void enableButtons();
    void disableButtons();
    OmSourceBrowser *_browser; 
    OmImageDisplay *_imageDisplay;
    OmSourceParameter* _source;
   
    OmSourceButton* _deleteListBtn;    
    OmSourceButton* _okBtn;    
    OmSourceButton* _cancelBtn;    

    OmSourceLabel* _label;
    QTable *_table;
    OmSpinBox*  _spinBoxColour1;
    OmSpinBox*  _spinBoxColour2;
    QSpinBox*  _spinBoxUpdate;
  
    QTimer *_timer;
    QTimer *_regionTimer;

    float _apertureRadius; 
    


    OmSourceLabel* _apertureTxt;
    QSpinBox* _apertureSpinBox;
    QCheckBox* _centroidButton;  
 
    vector<float>  _radiusList; 
    float _nx, _ny;
    int _time;
    bool _oldSources;       

};

#endif




